"use strict";
cc._RF.push(module, '82ae4btqhJPcIb1z6kQOzM8', 'MaskLight');
// Script/MaskLight.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var MaskLight = /** @class */ (function (_super) {
    __extends(MaskLight, _super);
    function MaskLight() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.maskSprite = null;
        _this.pointLightMap = {};
        _this.mat = null;
        _this.widthHalf = cc.winSize.width / 2;
        _this.heightHalf = cc.winSize.height / 2;
        return _this;
    }
    MaskLight.prototype.onLoad = function () {
        this.mat = this.maskSprite.getMaterial(0);
        this.mat.setProperty("wh_ratio", this.widthHalf / this.heightHalf);
        this.imAddPointLight(-100, 300);
        this.imAddPointLight(-100, 100, 100);
        this.imAddPointLight(200, 200, 200);
        this.imAddPointLight(-300, 0, 200, 0.5);
    };
    MaskLight.prototype.imAddPointLight = function (x, y, radius, value) {
        if (radius === void 0) { radius = 375; }
        if (value === void 0) { value = 1; }
        var idx = 0;
        for (var i = 1; i <= 5; i++) {
            if (this.pointLightMap[i] == undefined) {
                var v4 = new cc.Vec4(x, y, 0, value);
                this.pointLightMap[i] = v4;
                idx = i;
                break;
            }
            else if (this.pointLightMap[i].w <= 0) {
                idx = i;
                break;
            }
        }
        if (idx == 0)
            return;
        this.pointLightMap[idx].x = x / this.widthHalf;
        this.pointLightMap[idx].y = y / this.heightHalf;
        this.pointLightMap[idx].z = radius / cc.winSize.height;
        this.pointLightMap[idx].w = value;
        this.mat.setProperty("center" + idx, this.pointLightMap[idx]);
        return idx;
    };
    //关闭某个点灯光
    MaskLight.prototype.imClosePointLight = function (idx) {
        if (this.pointLightMap[idx] && this.pointLightMap[idx].w > 0) {
            this.pointLightMap[idx].w = -0.1;
            this.mat.setProperty("center" + idx, this.pointLightMap[idx]);
        }
    };
    __decorate([
        property(cc.Sprite)
    ], MaskLight.prototype, "maskSprite", void 0);
    MaskLight = __decorate([
        ccclass
    ], MaskLight);
    return MaskLight;
}(cc.Component));
exports.default = MaskLight;

cc._RF.pop();